package org.nuiton.topiatest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang3.builder.ToStringBuilder;

public class BillDTO implements Serializable {

    public int cost;

    public Date date;

    public Boolean paid;

    public StoreDTO store;

    public CompanyDTO company;

    protected final PropertyChangeSupport p = new PropertyChangeSupport(this);

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        p.addPropertyChangeListener(listener);
    }

    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        p.removePropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.removePropertyChangeListener(propertyName, listener);
    }

    public void setCost(int value) {
        int oldValue = this.cost;
        this.cost = value;
        p.firePropertyChange("cost", oldValue, value);
    }

    public int getCost() {
        return cost;
    }

    public void setDate(Date value) {
        java.util.Date oldValue = this.date;
        this.date = value;
        p.firePropertyChange("date", oldValue, value);
    }

    public Date getDate() {
        return date;
    }

    public void setPaid(Boolean value) {
        java.lang.Boolean oldValue = this.paid;
        this.paid = value;
        p.firePropertyChange("paid", oldValue, value);
    }

    public Boolean getPaid() {
        return paid;
    }

    public String toString() {
        String result = new ToStringBuilder(this).
            append("cost", this.cost).
            append("date", this.date).
            append("paid", this.paid).
         toString();
        return result;
}

} //BillDTO
