package org.nuiton.topiatest;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.io.Serializable;
import org.apache.commons.lang3.builder.ToStringBuilder;

public class CompanyDTO implements Serializable {

    public String name;

    public int siret;

    public EmployeDTO[] employe;

    public BillDTO[] storeBill;

    public DepartmentDTO[] department;

    protected final PropertyChangeSupport p = new PropertyChangeSupport(this);

    public void addPropertyChangeListener(PropertyChangeListener listener) {
        p.addPropertyChangeListener(listener);
    }

    public void addPropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.addPropertyChangeListener(propertyName, listener);
    }

    public void removePropertyChangeListener(PropertyChangeListener listener) {
        p.removePropertyChangeListener(listener);
    }

    public void removePropertyChangeListener(String propertyName, PropertyChangeListener listener) {
        p.removePropertyChangeListener(propertyName, listener);
    }

    public void setName(String value) {
        java.lang.String oldValue = this.name;
        this.name = value;
        p.firePropertyChange("name", oldValue, value);
    }

    public String getName() {
        return name;
    }

    public void setSiret(int value) {
        int oldValue = this.siret;
        this.siret = value;
        p.firePropertyChange("siret", oldValue, value);
    }

    public int getSiret() {
        return siret;
    }

    public void setEmploye(EmployeDTO[] values) {
        org.nuiton.topiatest.EmployeDTO[] oldValues = this.employe;
        this.employe = values;
        p.firePropertyChange("employe", oldValues, values);
    }

    public EmployeDTO[] getEmploye() {
        return employe;
    }

    public void setStoreBill(BillDTO[] values) {
        org.nuiton.topiatest.BillDTO[] oldValues = this.storeBill;
        this.storeBill = values;
        p.firePropertyChange("store", oldValues, values);
    }

    public BillDTO[] getStoreBill() {
        return this.storeBill;
    }

    public void setDepartment(DepartmentDTO[] values) {
        org.nuiton.topiatest.DepartmentDTO[] oldValues = this.department;
        this.department = values;
        p.firePropertyChange("department", oldValues, values);
    }

    public DepartmentDTO[] getDepartment() {
        return department;
    }

    public String toString() {
        String result = new ToStringBuilder(this).
            append("name", this.name).
            append("siret", this.siret).
            append("employe", this.employe).
         toString();
        return result;
}

} //CompanyDTO
